Index: /trunk/src/org/expeditee/items/widgets/charts/AbstractChart.java
===================================================================
--- /trunk/src/org/expeditee/items/widgets/charts/AbstractChart.java	(revision 375)
+++ /trunk/src/org/expeditee/items/widgets/charts/AbstractChart.java	(revision 376)
@@ -85,17 +85,19 @@
 				case SizeUp:
 					invalidateLink();
-					FrameKeyboardActions.SetSize(getFirstCorner(), 1, false, true);
+					FrameKeyboardActions.SetSize(getFirstCorner(), 1, false,
+							true);
 					invalidateSelf();
 					FrameGraphics.refresh(true);
-					//FrameGraphics.requestRefresh(true);
+					// FrameGraphics.requestRefresh(true);
 					break;
 				case SizeDown:
 					invalidateLink();
-					FrameKeyboardActions.SetSize(getFirstCorner(), -1, false, true);
+					FrameKeyboardActions.SetSize(getFirstCorner(), -1, false,
+							true);
 					invalidateSelf();
 					FrameGraphics.refresh(true);
-					//FrameGraphics.ForceRepaint();
-					//FrameGraphics.refresh(true);
-					//FrameGraphics.requestRefresh(true);
+					// FrameGraphics.ForceRepaint();
+					// FrameGraphics.refresh(true);
+					// FrameGraphics.requestRefresh(true);
 					break;
 				case ChangeColor:
@@ -221,4 +223,5 @@
 	protected void refreshData(Frame dataFrame) {
 		clearSubjects();
+		
 		boolean swap = false;
 		if (dataFrame.hasAnnotation("swap")) {
@@ -265,4 +268,8 @@
 		}
 		/* if (foundData) */{
+			/*
+			 * At minimum add the data frame as a subject even if there is no data
+			 * on it... yet
+			 */
 			addSubject(dataFrame);
 		}
@@ -362,5 +369,5 @@
 		if (legend != null) {
 			legend.setFrame(new BlockBorder(newThickness, newThickness,
-					newThickness, newThickness, getSource().getColor()));
+					newThickness, newThickness, getSource().getPaintColor()));
 			legend.setItemFont(legend.getItemFont().deriveFont(fontSize));
 			float pad = newThickness + 1;
Index: /trunk/src/org/expeditee/math/ExpediteeJEP.java
===================================================================
--- /trunk/src/org/expeditee/math/ExpediteeJEP.java	(revision 375)
+++ /trunk/src/org/expeditee/math/ExpediteeJEP.java	(revision 376)
@@ -84,10 +84,13 @@
 				continue;
 
-			AttributeValuePair avp = new AttributeValuePair(t.getText());
+			AttributeValuePair avp = t.getAttributeValuePair();
 			if (avp.hasPair()) {
 				try {
-					if (getVar(avp.getAttribute()) == null)
-						addVariable(avp.getAttribute(), avp.getDoubleValue());
-				} catch (NumberFormatException e) {
+					if (getVar(avp.getAttribute()) == null) {
+						Double d = avp.getDoubleValue();
+						if (!d.equals(Double.NaN))
+							addVariable(avp.getAttribute(), avp
+									.getDoubleValue());
+					}
 				} catch (Exception e) {
 					e.printStackTrace();
@@ -111,10 +114,10 @@
 			if (i instanceof Text && !i.isAnnotation() && !i.isLineEnd()) {
 				try {
-					Double value = new AttributeValuePair(i.getText())
-							.getDoubleValue();
-					if (value != null) {
+					Double value = i.getAttributeValuePair().getDoubleValue();
+					if (!value.equals(Double.NaN)) {
 						vector.add(value);
 					}
-				} catch (NumberFormatException e) {
+				} catch (Exception e) {
+					e.printStackTrace();
 				}
 			}
Index: /trunk/src/org/expeditee/simple/SString.java
===================================================================
--- /trunk/src/org/expeditee/simple/SString.java	(revision 375)
+++ /trunk/src/org/expeditee/simple/SString.java	(revision 376)
@@ -3,4 +3,6 @@
 public class SString extends SPrimitive<String> {
 	public static String prefix = SVariable.prefix + "s" + SVariable.separator;
+
+	Double doubleValue_ = null;
 
 	public SString() {
@@ -12,5 +14,5 @@
 	}
 
-	public SString(String value) /*throws Exception*/ {
+	public SString(String value) /* throws Exception */{
 		super(value);
 	}
@@ -19,4 +21,5 @@
 	public void parse(String s) {
 		value_ = s;
+		doubleValue_ = null;
 	}
 
@@ -39,11 +42,21 @@
 	@Override
 	public Double doubleValue() {
+		if (doubleValue_ != null)
+			return doubleValue_;
+
 		if (value_.equals(""))
-			return 0.0;
-		try {
-			return Double.parseDouble(value_);
-		} catch (NumberFormatException ne) {
+			doubleValue_ = 0.0;
+		else {
+			try {
+				doubleValue_ = Double.parseDouble(value_);
+			} catch (NumberFormatException ne) {
+				try{
+				doubleValue_ =(double) Long.decode(value_);
+				}catch(Exception e){
+					doubleValue_ = Double.NaN;
+				}
+			}
 		}
-		return (double) Long.decode(value_);
+		return doubleValue_;
 	}
 
@@ -64,4 +77,5 @@
 	public void setValue(SPrimitive v) {
 		value_ = v.stringValue();
+		doubleValue_ = null;
 	}
 
Index: /trunk/src/org/expeditee/stats/DocumentStats.java
===================================================================
--- /trunk/src/org/expeditee/stats/DocumentStats.java	(revision 375)
+++ /trunk/src/org/expeditee/stats/DocumentStats.java	(revision 376)
@@ -12,4 +12,6 @@
 	protected int _treeFrames = 0;
 
+	protected int _characters = 0;
+	
 	protected int _words = 0;
 
@@ -33,4 +35,5 @@
 
 		// Initialise variables with the data for this frames comet
+		_characters = 0;
 		_words = 0;
 		_textItems = 0;
@@ -44,4 +47,5 @@
 			_words += text.split("\\s+").length;
 			_sentances += text.split("\\.+").length;
+			_characters += text.length();
 			
 			String link = i.getAbsoluteLink();
@@ -59,4 +63,5 @@
 					visited);
 			_words += childItemStats._words;
+			_characters += childItemStats._characters;
 			_textItems += childItemStats._textItems;
 			_sentances += childItemStats._sentances;
@@ -69,10 +74,11 @@
 		StringBuffer sb = new StringBuffer();
 		sb.append(SessionStats.getDate());
-		sb.append("DocStats:  ").append(_name).append('\n');
-		sb.append("Title:  ").append(_title).append('\n');
+		sb.append("DocStats: ").append(_name).append('\n');
+		sb.append("Title:    ").append(_title).append('\n');
 		sb.append("Frames:    ").append(_treeFrames).append('\n');
 		sb.append("TextItems: ").append(_textItems).append('\n');
 		sb.append("Sentances: ").append(_sentances).append('\n');
-		sb.append("Words:     ").append(_words);
+		sb.append("Words:     ").append(_words).append('\n');
+		sb.append("Chars:     ").append(_characters);
 		return sb.toString();
 	}
Index: /trunk/src/org/expeditee/stats/DocumentStatsFast.java
===================================================================
--- /trunk/src/org/expeditee/stats/DocumentStatsFast.java	(revision 376)
+++ /trunk/src/org/expeditee/stats/DocumentStatsFast.java	(revision 376)
@@ -0,0 +1,150 @@
+package org.expeditee.stats;
+
+import java.io.BufferedReader;
+import java.io.FileNotFoundException;
+import java.io.FileReader;
+import java.io.IOException;
+import java.util.HashSet;
+import java.util.Set;
+
+import org.expeditee.gui.AttributeValuePair;
+import org.expeditee.gui.FrameIO;
+import org.expeditee.gui.MessageBay;
+import org.expeditee.gui.UserSettings;
+import org.expeditee.io.Conversion;
+
+public class DocumentStatsFast extends Stats {
+	protected int _treeFrames = 0;
+	
+	protected int _characters = 0;
+
+	protected int _words = 0;
+
+	protected int _textItems = 0;
+
+	protected int _sentances = 0;
+
+	protected String _name = null;
+
+	protected String _title = null;
+
+	public static int wordCount(String paragraph) {
+		return paragraph.trim().split("\\s+").length + 1;
+	}
+
+	public DocumentStatsFast(String topFrame, String title) {
+		this(topFrame, new HashSet<String>());
+		_title = title;
+	}
+
+	public DocumentStatsFast(String topFrame, Set<String> visited) {
+		_name = topFrame;
+		String lowerName = _name.toLowerCase();
+
+		if (visited.contains(lowerName)) {
+			return;
+		}
+
+		visited.add(_name.toLowerCase());
+		MessageBay.overwriteMessage("Computed: " + _name);
+
+		// Initialise variables with the data for this frames comet
+		_words = 0;
+		_characters = 0;
+		_textItems = 0;
+		_sentances = 0;
+		_treeFrames = 1;
+
+		String fullPath = null;
+		for (String possiblePath : UserSettings.FrameDirs) {
+			fullPath = FrameIO.getFrameFullPathName(possiblePath, _name);
+			if (fullPath != null)
+				break;
+		}
+
+		// If the frame was not located return null
+		if (fullPath == null)
+			return;
+
+		String frameset = Conversion.getFramesetName(_name);
+
+		// Open the file and search the text items
+		try {
+			BufferedReader reader = new BufferedReader(new FileReader(fullPath));
+			String next;
+			StringBuffer sb = new StringBuffer();
+			String link = null;
+			boolean ignore = false;
+			while (reader.ready() && ((next = reader.readLine()) != null)) {
+				if (next.length() == 0) {
+					// Ignore annotations
+					if (ignore) {
+						ignore = false;
+						link = null;
+						continue;
+					}
+
+					// Ignore non text items
+					if (sb.length() == 0) {
+						link = null;
+						continue;
+					}
+
+					if (link == null) {
+						// remove the last newLine... not absolutely needed
+						String text = sb.substring(0, sb.length() - 1);
+						_textItems++;
+						_characters += text.length();
+						_words += text.split("\\s+").length;
+						_sentances += text.split("\\.+").length;
+					} else {
+						DocumentStatsFast childItemStats = new DocumentStatsFast(
+								link, visited);
+						_characters += childItemStats._characters;
+						_words += childItemStats._words;
+						_textItems += childItemStats._textItems;
+						_sentances += childItemStats._sentances;
+						_treeFrames += childItemStats._treeFrames;
+					}
+					// Reinit the item variables
+					link = null;
+					sb = new StringBuffer();
+				} else if (ignore) {
+					continue;
+				} else if (next.startsWith("T")) {
+					String text = next.substring(2).trim();
+					// Ignore the rest of annotation items...
+					if (text.length() > 0
+							&& text.charAt(0) == AttributeValuePair.ANNOTATION_CHAR) {
+						ignore = true;
+						continue;
+					}
+					sb.append(text).append('\n');
+				} else if (next.startsWith("F")) {
+					link = next.substring(2);
+					// Convert number only links
+					if (Character.isDigit(link.charAt(0)))
+						link = frameset + link;
+				}
+			}
+		} catch (FileNotFoundException e) {
+			e.printStackTrace();
+		} catch (IOException e) {
+			e.printStackTrace();
+		}
+	}
+
+	@Override
+	public String toString() {
+		StringBuffer sb = new StringBuffer();
+		sb.append(SessionStats.getDate());
+		sb.append("DocStats:  ").append(_name).append('\n');
+		sb.append("Title:  ").append(_title).append('\n');
+		sb.append("Frames:    ").append(_treeFrames).append('\n');
+		sb.append("TextItems: ").append(_textItems).append('\n');
+		sb.append("Sentances: ").append(_sentances).append('\n');
+		sb.append("Words:     ").append(_words).append('\n');
+		sb.append("Chars:     ").append(_characters);
+		return sb.toString();
+	}
+}
